/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jonas.jtests.clients.entity;

import javax.naming.NamingException;
import javax.rmi.PortableRemoteObject;
import junit.framework.Test;
import junit.framework.TestSuite;
import org.objectweb.jonas.jtests.beans.ebasic.AccountHome;
import org.objectweb.jonas.jtests.beans.ebasic.PersonHome;

/**
 * These are tests about the different cases of the primary key type for CMP version 2 entity.
 * All common tests to CMP version 1 and CMP version 2 are in the inherited class.
 * @author Helene Joanin (jonas team)
 */
public class F_VariousPKEC2 extends A_VariousPKEC {

    private static String BEAN_HOME_ACCOUNT = "ebasicAccountEC2Home";
    protected static AccountHome ahome = null;
    private static String BEAN_HOME_PERSON = "ebasicPersonEC2Home";
    protected static PersonHome phome = null;

    public F_VariousPKEC2(String name) {
        super(name);
    }

    protected void setUp() {
        super.setUp();
    }

    public AccountHome getAccountHome() {
        if (ahome == null) {
            try {
                ahome = (AccountHome) PortableRemoteObject.narrow(ictx.lookup(BEAN_HOME_ACCOUNT), AccountHome.class);
            } catch (NamingException e) {
                fail("Cannot get bean home: " + BEAN_HOME_ACCOUNT);
            }
            // init here tables if CMP2
            try {
                ahome.create(0, "to be removed");
                ahome.create(10, "Eric");
                ahome.create(20, "Helene");
                ahome.create(30, "Guilhem");
                ahome.create(40, "Malva");
            } catch (Exception i) {
            }
        }
        return ahome;
    }

    public PersonHome getPersonHome() {
        if (phome == null) {
            try {
                phome = (PersonHome) PortableRemoteObject.narrow(ictx.lookup(BEAN_HOME_PERSON), PersonHome.class);
            } catch (NamingException e) {
                fail("Cannot get bean home: " + BEAN_HOME_PERSON);
            }
            // init here tables if CMP2
            try {
                phome.create(0, "to be removed");
                phome.create(10, "Eric");
                phome.create(20, "Helene");
                phome.create(30, "Guilhem");
                phome.create(40, "Malva");
            } catch (Exception i) {
            }
        }
        return phome;
    }

    public static Test suite() {
        return new TestSuite(F_VariousPKEC2.class);
    }

    public static void main (String args[]) {
        String testtorun = null;
        // Get args
        for (int argn = 0; argn < args.length; argn++) {
            String s_arg = args[argn];
            Integer i_arg;
            if (s_arg.equals("-n")) {
                testtorun = args[++argn];
            }
        }
        if (testtorun == null) {
            junit.textui.TestRunner.run(suite());
        } else {
            junit.textui.TestRunner.run(new F_VariousPKEC2(testtorun));
        }
    }
}
